#import "fontawesome.typ": fa, globe, github, linkedin, envelope
#import "lib.typ": template, work_entry, project, indent, SMALL_STRONG, DEFAULT_STRONG

// orange!!
#let color = blue // rgb("#ff983e")
#let name = "Daniel Chen"

#let contact_data = ((
  service: fa[#globe],
  display: "eggworld.me",
  link: "https://eggworld.me",
), (
  service: fa[#github],
  display: "github.com/potatoeggy",
  link: "https://github.com/potatoeggy",
), (
  service: fa[#linkedin],
  display: "linkedin.com/in/potatoeggy",
  link: "https://www.linkedin.com/in/potatoeggy/",
), (
  service: fa[#envelope],
  display: "d7chen@uwaterloo.ca",
  link: "mailto://d7chen@uwaterloo.ca",
),)

#show: doc => template(name, contact_data, color, doc)

// MAIN CONTENT STARTS here

= Skills

#indent[
  *Languages:* Python, TypeScript, JavaScript, Rust, SQL, C, C++, Java,
  HTML, CSS \
  // MATLAB, Dart
  *Frameworks:* Node.js, Express, Spring Boot, React, Next.js, Vue, Flutter, Axum \
  // Qt, Jest / Pytest, Apollo, Prisma
  *Tools:* Linux, Git, Docker, PostgreSQL, Redis, Kubernetes, AWS, GCP,
  OpenTelemetry, GraphQL, Android
  // Jenkins, Terraform, systemd, nginx, Jira
]

= Experience

#indent[
  #work_entry(
    "Software Developer Intern",
    "Immigr8",
    start_date: "Jan 2024",
    end_date: "Apr 2024",
    location: "Clearwater, FL",
    tools: "TypeScript, Java, AWS, Next.js, Spring Boot, PostgreSQL",
    tasks: (
      [ci/cd pipeline w/aws, ec2, jenkins, terraform, stasging env], // TODO
      [jwts, auth, user management, user roles, permissions],
      [frontend performance, limiting data over network, stale-while-revalidate, limit joins]
    )
  )
]

#indent[
  #work_entry(
    "Software Engineering Intern",
    "Dropbase",
    start_date: "May 2023",
    end_date: "Aug 2023",
    location: "San Francisco, CA",
    tools: "Python, TypeScript, FastAPI, AWS, React, PostgreSQL",
    tasks: (
      [Designed a conflict resolution algorithm for business smart tables, *reducing
        unrecoverable errors by 75%*],
      [Shipped a HubSpot/Airtable to Google Sheets sync feature to *46000+ enterprise
        users* by writing *AWS Lambda* functions in Python, abstracting interfaces to
        easily support future sources],
      [Wrote and deployed a new *React* data query builder to *33000+ users* by
        standardising and enforcing protocols between interfaces across the stack,
        eliminating the need for business users to manually write API calls],
      [??? ETL pipeline Launched a service to validate and import CSV/Excel attachments into DBs by
        expanding engine support by *6x*],
        // reference • Developed a scalable microservice that asynchronously ingests email attachments directly into ETL pipelines
      [??? emphasise test driven development or remove line *Reduced request errors by 30%* by creating backend testing infrastructure with
        *Pytest* to catch regressions and test new features across database engines with
        *90% code coverage*],
    ),
  )

  #work_entry(
    "Backend Developer & Organiser",
    "Hack the North",
    start_date: "Mar 2023",
    end_date: "Oct 2023",
    location: "Waterloo, ON",
    tools: "TypeScript, GraphQL, Docker, Kubernetes",
    tasks: (
      [Streamlined event check-in times by *80%* by generating user-specific Apple Wallet passes over *Express*],
      [?? Include redis sentinel Horizontally scaled the *Node* server to handle *1000+ concurrent users* with
        *Redis* and *Kubernetes*],
      [?? observability and analytics platform Integrated backend *tracing* to monitor performance and trigger alerts with
        *OpenTelemetry* and *Grafana*],
      [?? kubernetes and debouncing story],
      [Deployed a new attendee bus registration platform by creating new database
        tables and *GraphQL* resolvers],
      [Slashed boot and reload times by *93%* by introducing *threading, profiling*,
        and pre-transpiling generated code],
    ),
  )
]

= Projects
#set strong(delta: SMALL_STRONG)

#indent[
  // #project("Comic Downloader", "Python, Qt", 
  // repo_link: "https://github.com/potatoeggy/mandown")
  // - Created a CLI and GUI to scrape, download, and convert webcomics into
  //   e-ink-optimised ebooks (EPUB, PDF)
  // - Designed an *intermediate representation* to store metadata and images as a
  //   standardised conversion target
  // - Implemented *image caching and multiprocessing* to increase download and update
  //   speeds by *300%*

  #project(
    "Genshin Simulator",
    "Vue, TypeScript",
    repo_link: "https://github.com/potatoeggy/primoprod",
    demo_link: "https://primoprod.vercel.app"
  )
  - Built a realistic and beautiful *loot box simulator* with fluid animations based
    off a popular game
  - Reduced action latency by *90%* by lazily loading art assets at opportune times,
    such as during cutscenes

  #project("Kobo Sync Server", "Rust, Axum", repo_link: "https://github.com/potatoeggy/kobink")
  - Developed an Axum backend to *automatically convert and sync* ebooks to a Kobo
    eReader over the network
  - *Reverse-engineered* the Kobo eReader Sync API to support updating ebook
    metadata and covers

  // #project(
  //   "RecipeReady",
  //   "https://github.com/vincentjguo/recipeready-server",
  //   "Flutter, Selenium, FastAPI, Android",
  // )
  // - Developed a *Flutter app* to generate recipes based on ingredients and filters
  //   through a FastAPI server
  // - Scraped thousands of websites for recipes to build a database with a robust
  //   *many-to-many tag system*
  // - Aggregated common ingredients heuristically to build a shopping list and a meal
  // plan for each week

  // #project("Arch Linux Server", "Linux, Docker, nginx, systemd", demo_link: "https://eggworld.me")
  // - Created a *self-hosted CI/CD pipeline* with *Gitea* to automatically deploy
  //   personal projects behind *nginx*
  // - Containerised services with *Docker* and *systemd* to simplify deployment and
  //   management
  
  #project("Game Boy Advance Emulator", "Rust, SDL2, Vulkan", repo_link: "https://github.com/potatoeggy/gbarr")
  // - Implemented a *GBA emulator* with *SDL2* and *Vulkan* to run games on modern
  //   hardware
  // - Optimised the CPU core to run at *full speed* by *precompiling* instructions and
  //   *parallelising* execution
  - ???
  - ???
]

= Education

#indent[
  #work_entry(
    "University of Waterloo",
    "B.A.Sc. in Computer Engineering",
    start_date: "Sep 2022",
    end_date: "Apr 2027",
    location: "Waterloo, ON",
    tasks: (
      [Courses: Object-oriented programming, data structures & algorithms, digital
        computers & circuits],
      [Extracurriculars: Creative Writing Club, Hack the North, UW Orbital Design Team]
    ),
  )
]

// = Awards

// #show link: underline

// - Winner of the #link("https://github.com/anyuan-chen/resketch")[EdTech] prize at
//   StormHacks 2022 from 350+ participants
// - Winner of the #link("https://github.com/anyuan-chen/perdiem")[IBM Open Source] prize
//   at YRHacks 2022 from 90+ participants
